﻿#target indesign  
  
function main() {  
     if (isOSX()) {  
          var csvFile = File.openDialog('Select a CSV File', function (f) { return (f instanceof Folder) || f.name.match(/\.csv$/i);} );  
     } else {  
          var csvFile = File.openDialog('Select a CSV File','comma-separated-values(*.csv):*.csv;');  
     }  
     if (csvFile != null) {  
          fileArray = readInCSV(csvFile);  
          var columns = fileArray[0].length;  
          //alert('CSV file has ' + columns + ' columns…');  
          var rows = fileArray.length;  
          //alert('CSV file has ' + rows + ' rows…');  
          if (columns == 5 && rows > 0) {  
               exchangeSwatches(csvFile);  
          } else {  
               var mess = 'Incorrect CSV File?';  
               isOSX ? saySomething(mess) : alert(mess);  
          }  
     } else {  
          var mess = 'Ooops!!!';  
          isOSX ? saySomething(mess) : alert(mess);  
     }  
}  
  
main();  
  
function exchangeSwatches(csvFile) {  
     var docRef = app.documents.add();  
     with (docRef) {       
          for (var i = unusedSwatches.length-1; i >= 0; i--) {  
               unusedSwatches[i].remove();  
          }  
          for (var a = 0; a < fileArray.length; a++) {  
               var b = fileArray[a][0]; // First Column is name                 
               if (b == 'Cyan' || b == 'Magenta' || b == 'Yellow' || b == 'Black') {            
                    b = b + '-???'; // Reserved swatch name;  
               }            
               c = parseFloat(fileArray[a][1]); // Second Column is Cyan  
               m = parseFloat(fileArray[a][2]); // Third Column is Magenta  
               y = parseFloat(fileArray[a][3]); // Forth Column is Yellow  
               k = parseFloat(fileArray[a][4]); // Fifth Column is Black  
               if (c >= 0 && c <= 100 && m >= 0 && m <= 100 && y >= 0 && y <= 100 && k >= 0 && k <= 100) {  
                    var colArray = new Array(c, m, y, k);  
                    var col = colors.add({model:ColorModel.process, space:ColorSpace.cmyk, colorValue:colArray, name:b});  
               } else {  
                    var mess = 'Color values are out of range?';  
                    isOSX ? saySomething(mess) : alert(mess);  
               }  
          }       
          var exchangeSwatches = swatches;  
          var savePath = csvFile.fsName.substring(0, csvFile.fsName.length - 4);  
          var aseFile = new File(savePath + '.ase');  
          saveSwatches(aseFile, exchangeSwatches);  
          close(SaveOptions.no);   
     }  
}  
  
function readInCSV(fileObj) {  
     var fileArray = new Array();  
     fileObj.open('r');  
     fileObj.seek(0, 0);  
     while(!fileObj.eof) {  
          var thisLine = fileObj.readln();  
          var csvArray = thisLine.split(',');  
          fileArray.push(csvArray);  
     }  
     fileObj.close();  
     return fileArray;  
}  
  
function saySomething(stringObj) {  
     var speakThis = 'say "' + stringObj + '" using "Fred"';  
     app.doScript(speakThis, 1095978087); // AppleScript  
}  
  
function isOSX() {  
  return $.os.match(/Macintosh/i); 
}